/*
 * The olsr.org Optimized Link-State Routing daemon(olsrd)
 * Copyright (c) 2004, Thomas Lopatic (thomas@lopatic.de)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 *
 * * Redistributions of source code must retain the above copyright 
 *   notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright 
 *   notice, this list of conditions and the following disclaimer in 
 *   the documentation and/or other materials provided with the 
 *   distribution.
 * * Neither the name of olsr.org, olsrd nor the names of its 
 *   contributors may be used to endorse or promote products derived 
 *   from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Visit http://www.olsr.org for more information.
 *
 * If you find this software useful feel free to make a donation
 * to the project. For more information see the website or contact
 * the copyright holders.
 *
 * $Id: lq_list.h,v 1.3 2005/02/20 18:52:18 kattemat Exp $
 */

#ifndef _LQ_LIST_H
#define _LQ_LIST_H

struct list_node
{
  struct list_node *next;
  struct list_node *prev;

  void *data;
};

struct list
{
  struct list_node *head;
  struct list_node *tail;
};

void list_init(struct list *list);

#ifdef SVEN_OLA
#define list_get_head(node) (node)->head
#define list_get_tail(node) (node)->tail
#define list_get_next(node) (node)->next
#define list_get_prev(node) (node)->prev
#else
struct list_node *list_get_head(struct list *list);
struct list_node *list_get_tail(struct list *list);

struct list_node *list_get_next(struct list_node *node);
struct list_node *list_get_prev(struct list_node *node);
#endif

void list_add_head(struct list *list, struct list_node *node);
void list_add_tail(struct list *list, struct list_node *node);

void list_add_before(struct list *list, struct list_node *pos_node,
                     struct list_node *node);
void list_add_after(struct list *list, struct list_node *pos_node,
                    struct list_node *node);

void list_remove(struct list *list, struct list_node *node);

#endif

